#define AREF 3.33; //connect AREF pin to 3.3V

#define FREQUENCY 3 //blinks per second in units Hz(cycles per second)
#define DUTY_CYCLE 0.25 //ration of ON_TIME to total time per blink or period

#define PERIOD 1000/FREQUENCY //how long the blink takes
#define ON_TIME DUTY_CYCLE * PERIOD //the time the led is on
#define OFF_TIME PERIOD - ON_TIME //the time the led is off

#include "FastLED.h"

int analoginput = 5; // our analog pin
int analogamount = 0; // stores incoming value
float percentage = 0; // used to store our percentage value
float voltage =0; // used to store voltage value

// defines pins numbers
const int trigPin = 3;
const int echoPin = 4;

// defines variables
long duration;
int distance;

// Motor R

int enB = 5;
int in3 = 6;
int in4 = 7;

// Motor L

int enA = 11;
int in1 = 9;
int in2 = 8;

int motorSpeedR = 90;
int motorSpeedL = 90;

CRGB leds[1]; 
// Generally, you should use "unsigned long" for variables that hold time
// The value will quickly become too large for an int to store
unsigned long previousMillis = 0;        // will store last time LED was updated
unsigned long previousMillisU = 0;       // will store last time delay was updated
boolean On;
boolean Drive_State;
boolean OUT = true;
const long Interval = 500;
void setup()
{
  pinMode(enA, OUTPUT);
  pinMode(enB, OUTPUT);
  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);
  pinMode(in3, OUTPUT);
  pinMode(in4, OUTPUT);
  pinMode(trigPin, OUTPUT); // Sets the trigPin as an Output
  pinMode(echoPin, INPUT); // Sets the echoPin as an Input
  FastLED.addLeds<NEOPIXEL, 13>(leds, 1); 
  FastLED.setBrightness(100);
  leds[0] = CRGB::Black;
  FastLED.show();
  Serial.begin(9600);
  analogReference(EXTERNAL); // use AREF for reference voltage
}

void Roomba() {    //creates function which runs Ultrasonic sensor
 if(OUT == true){
  // Clears the trigPin
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  //  Sets the trigPin on HIGH state for 10 micro seconds
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  // Reads the echoPin, returns the sound wave travel time in microseconds
  duration = pulseIn(echoPin, HIGH);
  // Calculating the distance
  distance= duration*0.034/2;
  Serial.print("Distance: ");
  Serial.println(distance);
  digitalWrite(in3, HIGH);// forward motor R
  digitalWrite(in4, LOW);
  digitalWrite(in1, LOW);// forward motor L
  digitalWrite(in2, HIGH);
  int motorSpeedR = 100;
  int motorSpeedL = 100;
  analogWrite(enA, motorSpeedL);// Set speed to 200 out of possible range 0~255
  analogWrite(enB, motorSpeedR);// Set speed to 200 out of possible range 0~255

 }
  
  if (distance == 0){ //zero makes the sensor unreliable so change zero to 3
    distance = 3;
  }
  
  if (distance < 20 && distance > 2) //tells it to reverse if the distance is less than 30 but greater than 2 because zero will break it
  {
    unsigned long currentMillisU = millis();
    digitalWrite(in3, LOW);// Reverse motor L
    digitalWrite(in4, HIGH);
    digitalWrite(in1, HIGH);// Reverse motor R
    digitalWrite(in2, LOW);
    motorSpeedR = 100;
    motorSpeedL = 100;
    analogWrite(enA, motorSpeedR);// Set speed to variable out of possible range 0~255
    analogWrite(enB, motorSpeedL);// Set speed to variable out of possible range 0~255
    OUT = false;
  if (currentMillisU - previousMillisU >= Interval && Drive_State == false) {
      previousMillisU = currentMillisU; //reset clock
      digitalWrite(in3, LOW);// Forward motor L
      digitalWrite(in4, HIGH);
      digitalWrite(in1, LOW);// Forward motor R
      digitalWrite(in2, HIGH);
      motorSpeedR = 160;
      motorSpeedL = 100;
      analogWrite(enA, motorSpeedR);// Set speed to variable out of possible range 0~255
      analogWrite(enB, motorSpeedL);// Set speed to variable out of possible range 0~255
      Drive_State = true;
    }
  if (currentMillisU - previousMillisU >= Interval && Drive_State == true) {
      previousMillisU = currentMillisU; //reset clock
      digitalWrite(in3, HIGH);// forward motor R
      digitalWrite(in4, LOW);
      digitalWrite(in1, LOW);// forward motor L
      digitalWrite(in2, HIGH);
      int motorSpeedR = 160;
      int motorSpeedL = 100;
      analogWrite(enA, motorSpeedL);// Set speed to 200 out of possible range 0~255
      analogWrite(enB, motorSpeedR);// Set speed to 200 out of possible range 0~255
      Drive_State = false;
      OUT = true;
    }
  }
 
}

void voltageMonitor(){
  // check to see if it's time to blink the LED; that is, if the difference
  // between the current time and last time you blinked the LED is bigger than
  // the interval at which you want to blink the LED.
  unsigned long currentMillis = millis();
  analogamount=analogRead(analoginput);
  percentage=(analogamount/1024.00);
  voltage= percentage * (8.4/3.23) * AREF; // in Volts
  
  Serial.print("A0 (V): ");
  Serial.println(voltage,2);

  if (voltage >= 7.0) {
      leds[0] = CRGB::Green;
      FastLED.show();
    }

  if (voltage < 7.0 && voltage >= 6.6 ) {
      leds[0] = CRGB::Orange;
      FastLED.show();
    }   

  if (voltage < 6.6){
    if (currentMillis - previousMillis >= OFF_TIME && On == false) {
      previousMillis = currentMillis; //reset clock
 
      leds[0] = CRGB::Red;
      FastLED.setBrightness(30);
      FastLED.show();
      On = true;

    }

    if(currentMillis - previousMillis >= ON_TIME && On == true) {
      previousMillis = currentMillis; //reset clock
      
      leds[0] = CRGB::Black;
      FastLED.setBrightness(30);
      FastLED.show();
      On = false;
    }
       
  }
}

void loop(){
  voltageMonitor();
  Roomba();
  
}
